using namespace std;
#include <complex>
#include <fstream>
#include <iostream>
#include <string>
#include <new>
#include "MS.h"
#include "BS.h"
#include "rv_generate.h"
#include "Link.h"
#include "channel.h"
#include "sector.h"




extern unsigned long _seed;
extern Rand randnum;
extern int num_drop;
extern int run_times;
extern int test_environment;
extern int pathloss_model;
extern int num_neighbor;
extern double grid_interval;


extern double user_speed;
extern int CH_CAL;
extern int Calibration_mode;
extern int Scheduling_Type;
extern int scenario;
extern int Configuration_Type; /// For IMT-2020
extern int Channel_Model_Type; /// For IMT-2020
extern int TYPE;
extern int num_BS;
extern int num_MS;
extern int num_MS_persector;
extern int num_Indoor_TRxP;
extern int num_SECTORS;
extern int num_LINK;
extern int NUM_RX;
extern int NUM_TX;
extern int NUM_RX_Port;
extern int NUM_TX_Port;
extern int BS_M, BS_N, BS_Mg, BS_Ng, BS_Mp, BS_Np, BS_P;  /// tx antenna element
extern double BS_dH, BS_dV, BS_dgH, BS_dgV;
extern int MS_M, MS_N, MS_Mg, MS_Ng, MS_Mp, MS_Np, MS_P;  /// rx antenna element
extern double MS_dH, MS_dV, MS_dgH, MS_dgV;

extern complex <double> w[4][8];                              // [num_vertical steering angle][num element in a port] (maximum)
extern complex <double> v[4][8][8];                           // [num_vertical steering angle][num_horizontal sterring angle][num element in a port]  (maximum)
extern complex <double> virtualization_weight_wv[4][8][8][8]; // [vertical steering angle ][horizontal steering angle][vertical_element per port][horizontal_element per port]

extern complex <double> ue_w[4][8];                              // [num_vertical steering angle][num element in a port] (maximum)
extern complex <double> ue_v[4][8][8];                           // [num_vertical steering angle][num_horizontal sterring angle][num element in a port]  (maximum)
extern complex <double> ue_virtualization_weight_wv[4][8][8][8]; // [vertical steering angle ][horizontal steering angle][vertical_element per port][horizontal_element per port]

extern int tilt_azimuth_angle_LCS_size;
extern int tilt_zenith_angle_LCS_size;
extern int ue_tilt_azimuth_angle_LCS_size;
extern int ue_tilt_zenith_angle_LCS_size;

extern double bs_tilt_azimuth_angle_LCS[6];  //// pi
extern double bs_tilt_zenith_angle_LCS[2];  /// theta
extern double ue_tilt_azimuth_angle_LCS[4];  //// pi
extern double ue_tilt_zenith_angle_LCS[2];  /// theta

extern char * file_name;
extern double ** Capacity_avr_per_drop;

extern double W;
extern double h;
extern double Frequency;
extern double Wavelength;
extern double bs_maxpower;
extern double ms_maxpower;
extern double max_antgain;
extern double bandwidth;
extern double noise;
extern double BS_noisefig;
extern double MS_noisefig;
extern double ue_antenna_element_gain;
extern double Total_BS_Tx_power;

extern int num_floor;
extern int num_propagation_condition;

extern double bs_height;
extern double ms_height;
extern double ms_height_out;
extern double ms_height_in;
extern double inter_site_distance;
extern double min_distance;
extern double ANGLE_tilt;
extern double MAX_v_angle;

//mu_mimo..
extern double N_pf;
extern int cqi_history_length;
extern int num_rbs_in_1ms;
extern double            *** pppCQI_Map;
extern int               *** pppPMI_map;
//extern int SCHEDULE_TYPE;
extern int    mcs_decision;

extern int       mx_ue_mumimo;
extern double epsilon;
extern 	Matrix4cd WW[16];
extern Vector4cd code_word[64];

extern MatrixXcd **Hm[2][2];
extern int ** PMI_precalc[20000][2][2];
extern complex <double> **** CHIR_precalc[2][2];
extern double **sinr_estimate_precalc[20000][2][2];
extern double **sum_of_ch_coef_precalc[20000][2][2];

// CQI & Schedule Map
extern SCHEDULE_DECISION *** pppSchedule_Map;
//extern double            *** pppCQI_Map;
//extern int               *** pppPMI_map;



// simulation run variables
extern int t;
extern int drop_idx;

// simulation configure variables
extern int SCHEDULE_DELAY;
extern int num_compute_coef;
extern int precalculate_time;
extern int anglev_mapping_value;


//standard
extern double overhead;
extern double BLER_vienna[613][15];
extern int    TBS[51][27];
extern double NEW_TABLE[38][7][2];
extern double BLER_TABLE[38][7][2];
extern bool   calibration;
extern double * SNR;
extern double * SNR_dB;

//extern int num_path;
//extern double * delay;
//extern complex <double> *** CHIR;

//receive_downlink
extern int lls_mapping;
extern double CR_curves[38];
extern double Beta[15];
extern double SINR_threshold_dB[15];
extern double RBIR_value[3][95];
extern double Threshold[29];

//logging point
extern char path[50];


extern BS* bs;
extern MS* ms;
extern LINK* link;
extern CHANNEL** channel;
extern Sector* sector;




